<template>
  <div>
    <v-text-field
      label="Card Number"
      mask="###-###"
      v-model="cardNumber"
      :disabled="!!number"
      :rules="[v => numberRegex.test(v) || 'Invalid card number']"
      placeholder="000-000"
    />
    <qrcode-stream @decode="decode" v-if="!number && visible"></qrcode-stream>
  </div>
</template>

<script>
import gql from "graphql-tag";
import { QrcodeStream } from "vue-qrcode-reader";

export default {
  components: { QrcodeStream },
  props: {
    number: Number,
    value: Object,
    visible: { type: Boolean, default: true }
  },
  data() {
    return {
      // Consts
      numberRegex: /^[1-9][0-9]{5}$/,
      card: null,
      cardNumber: true
    };
  },
  mounted() {
    this.cardNumber = (this.value && this.value.number) || this.number;
  },
  watch: {
    number() {
      this.cardNumber = (this.value && this.value.number) || this.number;
    }
  },
  apollo: {
    card: {
      query: gql`
        query($cardNumber: Int!) {
          card(number: $cardNumber) {
            id
            number
            money
          }
        }
      `,
      subscribeToMore: {
        document: gql`
          subscription($id: ID!) {
            card(id: $id) {
              id
              number
              money
            }
          }
        `,
        skip() {
          return !this.card;
        },
        variables() {
          return {
            id: this.card.id
          };
        }
      },
      skip() {
        return !this.numberRegex.test(this.cardNumber);
      },
      result() {
        if (this.card) this.$emit("input", this.card);
        else this.$emit("input", { number: parseInt(this.cardNumber) });
      },
      variables() {
        return {
          cardNumber: parseInt(this.cardNumber)
        };
      }
    }
  },
  methods: {
    decode(val) {
      console.log(val);
      if (this.numberRegex.test(val)) this.cardNumber = val;
      else console.warn(`Invalid Card Number "${val}"`);
    }
  }
};
</script>
